#!/bin/bash
in_json_file=$1
composit_type=$2
job_name=$3
version=$4
work_dir=$5

export SPARK_MAJOR_VERSION=2
export SPARK_HOME=/usr/hdp/current/spark2-client
export PYSPARK_PYTHON="/usr/bin/python3.6"

keyfile="/opt/s5pbira/env/python36/site-packages/s5pbira/config/mep_cgs.keytab"

kinit -kt $keyfile mep_cgs
DIRNAME=`dirname $0`
cd ..

zip -r "/tmp/s5pbira.zip" s5pbira/*.py && \
  spark-submit --master yarn --queue mep_cgs --deploy-mode cluster \
  --name "${job_name}" \
  --conf spark.yarn.appMasterEnv.YARN_CONTAINER_RUNTIME_TYPE=docker --conf spark.executorEnv.YARN_CONTAINER_RUNTIME_TYPE=docker \
  --conf spark.yarn.appMasterEnv.YARN_CONTAINER_RUNTIME_DOCKER_IMAGE=vito-docker-private.artifactory.vgt.vito.be/s5p_harp1.13_patched \
  --conf spark.executorEnv.YARN_CONTAINER_RUNTIME_DOCKER_IMAGE=vito-docker-private.artifactory.vgt.vito.be/s5p_harp1.13_patched \
  --conf spark.yarn.appMasterEnv.YARN_CONTAINER_RUNTIME_DOCKER_MOUNTS=/var/lib/sss/pipes:/var/lib/sss/pipes:rw,/usr/hdp/current/:/usr/hdp/current/:ro,/etc/hadoop/conf/:/etc/hadoop/conf/:ro,/etc/krb5.conf:/etc/krb5.conf:ro,/data/MTDA/CGS_S5P:/data/MTDA/CGS_S5P:ro,${work_dir}:${work_dir}:rw \
  --conf spark.executorEnv.YARN_CONTAINER_RUNTIME_DOCKER_MOUNTS=/var/lib/sss/pipes:/var/lib/sss/pipes:rw,/usr/hdp/current/:/usr/hdp/current/:ro,/etc/hadoop/conf/:/etc/hadoop/conf/:ro,/etc/krb5.conf:/etc/krb5.conf:ro,/data/MTDA/CGS_S5P:/data/MTDA/CGS_S5P:ro,${work_dir}:${work_dir}:rw \
  --conf spark.executorEnv.INCLUDE=/usr/include/ --conf spark.executorEnv.LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/opt/harp/lib:/opt/coda/lib/ --conf spark.yarn.appMasterEnv.PYSPARK_PYTHON=/usr/bin/python3.6 \
  --conf spark.yarn.appMasterEnv.SPARK_HOME=/usr/hdp/current/spark2-client \
  --conf spark.yarn.appMasterEnv.SPARK_HOME=/usr/hdp/current/spark2-client \
  --conf spark.yarn.appMasterEnv.PYSPARK_DRIVER_PYTHON=/usr/bin/python3.6 \
  --conf spark.executorEnv.PYSPARK_PYTHON=/usr/bin/python3.6 \
  --conf spark.shuffle.service.enabled=true --conf spark.dynamicAllocation.enabled=true \
  --conf spark.dynamicAllocation.minExecutors=1 \
  --conf spark.yarn.submit.waitAppCompletion=true \
  --conf spark.yarn.executor.memoryOverhead=2G \
  --principal "mep_cgs@VGT.VITO.BE" \
  --keytab $keyfile \
  --executor-memory 512M --py-files /tmp/s5pbira.zip ${DIRNAME}/workflow_runner.py \
  --input ${in_json_file} \
  --composit_type ${composit_type} \
  --version ${version}
